unit DemoMain;
{ **************************************************************************************

       Demo for RADical Concept's TWin95FileOp Component.
       --------------------------------------------------

       Date : 3 May 97

       Version 1.0

       Copyright  1997 RADical Concept. All rights reserved.

*************************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, W95FileOps, FileCtrl;

type
  TForm1 = class(TForm)
    SourceFileListBox: TFileListBox;
    SourceDirectoryListBox: TDirectoryListBox;
    CopyButton: TButton;
    MoveButton: TButton;
    RenameButton: TButton;
    DeleteButton: TButton;
    ExitButton: TButton;
    SourceDriveComboBox: TDriveComboBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    DestinationDirectoryListBox: TDirectoryListBox;
    DestinationDriveComboBox: TDriveComboBox;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    OptionsButton: TButton;
    Win95FileOp1: TWin95FileOp;
    procedure CopyButtonClick(Sender: TObject);
    procedure MoveButtonClick(Sender: TObject);
    procedure RenameButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure SourceDriveComboBoxChange(Sender: TObject);
    procedure DestinationDriveComboBoxChange(Sender: TObject);
    procedure OptionsButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Rename, Options;

{$R *.DFM}

{-----------------------------------------------------------------------------------------}
procedure TForm1.CopyButtonClick(Sender: TObject);
begin
  { Set component DestinationDir property, call Copy files component method. }
  Win95FileOp1.DestinationDir := DestinationDirectoryListBox.Directory;
  Win95FileOp1.Copyfiles;
End;

{-----------------------------------------------------------------------------------------}
procedure TForm1.MoveButtonClick(Sender: TObject);
begin
  { Set component DestinationDir property, call Move files component method and refresh
    ListBox. }
  Win95FileOp1.DestinationDir := DestinationDirectoryListBox.Directory;
  Win95FileOp1.Movefiles;
  SourceFileListBox.Update;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.RenameButtonClick(Sender: TObject);
begin
  { Extract file name from full path. }
  RenameDialog.Edit1.Text := ExtractFileName(SourceFileListBox.FileName);
  { Show Rename Dialog. }
  RenameDialog.ShowModal;
  if RenameDialog.ModalResult = mrOK then
    begin
      { Rebuild path + file name. }
      Win95FileOp1.DestinationDir := SourceDirectoryListBox.Directory + '\'
                                     + RenameDialog.Edit1.Text;
      { Call Rename files component method and refresh ListBox. }
      Win95FileOp1.Renamefiles;
      SourceFileListBox.Update;
    end;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.DeleteButtonClick(Sender: TObject);
begin
  { Call Delete files component method and refresh ListBox. }
  Win95FileOp1.Deletefiles;
  SourceFileListBox.Update;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.ExitButtonClick(Sender: TObject);
begin
  { Close application. }
  Close;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.SourceDriveComboBoxChange(Sender: TObject);
begin
  { Update Source Directory ListBox. }
  SourceDirectoryListBox.Drive := SourceDriveComboBox.Drive;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.DestinationDriveComboBoxChange(Sender: TObject);
begin
  { Update Destination Directory ListBox. }
  DestinationDirectoryListBox.Drive := DestinationDriveComboBox.Drive;
end;

{-----------------------------------------------------------------------------------------}
procedure TForm1.OptionsButtonClick(Sender: TObject);
begin
  { Read component options into apropriate CheckBox's. }
  with OptionsDialog do
    begin
      ShowModalDialogsCheckBox.Checked := ShowModalDialogs in Win95FileOp1.Options;
      AllowUndoCheckBox.Checked := AllowUndo in Win95FileOp1.Options;
      FilesOnlyCheckBox.Checked := FilesOnly in Win95FileOp1.Options;
      MultiDestCheckBox.Checked := MultiDestinations in Win95FileOp1.Options;
      NoConfirmationCheckBox.Checked := NoConfirmation in Win95FileOp1.Options;
      NoConfirmMakeDirCheckBox.Checked := NoConfirmMakeDir in Win95FileOp1.Options;
      RenameOnCollisionCheckBox.Checked := RenameOnCollision in Win95FileOp1.Options;
      SilentCheckBox.Checked := Silent in Win95FileOp1.Options;
      SimpleProgressCheckBox.Checked := SimpleProgress in Win95FileOp1.Options;
      { Show the OPtions Dialog. }
      ShowModal;
      if OptionsDialog.ModalResult = mrOK then
        begin
          { Set component options from CheckBox states. }
          with Win95FileOp1 do
            begin
              Options := [];  // Clear options set.
              if ShowModalDialogsCheckBox.Checked then
                Options := Options + [ShowModalDialogs];
              if AllowUndoCheckBox.Checked then
                Options := Options + [AllowUndo];
              if FilesOnlyCheckBox.Checked then
                Options := Options + [FilesOnly];
              if MultiDestCheckBox.Checked then
                Options := Options + [MultiDestinations];
              if NoConfirmationCheckBox.Checked then
                Options := Options + [NoConfirmation];
              if NoConfirmMakeDirCheckBox.Checked then
                Options := Options + [NoConfirmMakeDir];
              if RenameOnCollisionCheckBox.Checked then
                Options := Options + [RenameOnCollision];
              if SilentCheckBox.Checked then
                Options := Options + [Silent];
              if SimpleProgressCheckBox.Checked then
                Options := Options + [SimpleProgress];
            end;
        end;
    end;
end;

{-----------------------------------------------------------------------------------------}
end.
